3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
39 remoteurl=${remoteurl%/}
48 remoteurl="${remoteurl%/*}"
51 remoteurl="${remoteurl%:*}"
55 die "cannot strip one component off url '$remoteurl'"
66 echo "$remoteurl$sep${url%/}"
70 # Get submodule info for registered submodules
71 # $@ = path to limit submodule list
75 git ls-files --error-unmatch --stage -- "$@" |
78 my ($null_sha1) = ("0" x 40);
81 my ($mode, $sha1, $stage, $path) =
82 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
83 next unless $mode eq "160000";
85 if (!$unmerged{$path}++) {
86 print "$mode $null_sha1 U\t$path\n";
96 # Map submodule path to submodule name
102 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
103 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
104 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
105 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
107 die "No submodule mapping found in .gitmodules for path '$path'"
114 # Prior to calling, cmd_update checks that a possibly existing
115 # path is not a git repository.
116 # Likewise, cmd_add checks that path does not exist at all,
117 # since it is the location of a new submodule.
125 if test -n "$reference"
127 git-clone "$reference" -n "$url" "$path"
129 git-clone -n "$url" "$path"
131 die "Clone of '$url' into submodule path '$path' failed"
135 # Add a new submodule to the working tree, .gitmodules and the index
139 # optional branch is stored in global branch variable
143 # parse $args after "submodule ... add".
148 case "$2" in '') usage ;; esac
159 case "$2" in '') usage ;; esac
160 reference="--reference=$2"
184 if test -z "$path"; then
185 path=$(echo "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
189 if test -z "$repo" -o -z "$path"; then
193 # assure repo is absolute or relative to parent
196 # dereference source url relative to parent's url
197 realrepo=$(resolve_relative_url "$repo") || exit
204 die "repo URL: '$repo' must be absolute or begin with ./|../"
209 # multiple //; leading ./; /./; /../; trailing /
210 path=$(printf '%s/\n' "$path" |
220 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
221 die "'$path' already exists in the index"
223 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
225 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
227 echo >&2 "Use -f if you really want to add it."
231 # perhaps the path exists and is already a git repo, else clone it
234 if test -d "$path"/.git -o -f "$path"/.git
236 echo "Adding existing repo at '$path' to the index"
238 die "'$path' already exists and is not a valid git repo"
243 url=$(resolve_relative_url "$repo") || exit
249 git config submodule."$path".url "$url"
252 module_clone "$path" "$realrepo" "$reference" || exit
256 # ash fails to wordsplit ${branch:+-b "$branch"...}
258 '') git checkout -f -q ;;
259 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
261 ) || die "Unable to checkout submodule '$path'"
264 git add $force "$path" ||
265 die "Failed to add submodule '$path'"
267 git config -f .gitmodules submodule."$path".path "$path" &&
268 git config -f .gitmodules submodule."$path".url "$repo" &&
269 git add --force .gitmodules ||
270 die "Failed to register submodule '$path'"
274 # Execute an arbitrary command sequence in each checked out
277 # $@ = command to execute
281 # parse $args after "submodule ... foreach".
304 while read mode sha1 stage path
306 if test -e "$path"/.git
308 say "Entering '$prefix$path'"
309 name=$(module_name "$path")
311 prefix="$prefix$path/"
315 if test -n "$recursive"
317 cmd_foreach "--recursive" "$@"
320 die "Stopping at '$path'; script returned non-zero status."
326 # Register submodules in .git/config
328 # $@ = requested paths (default to all)
332 # parse $args after "submodule ... init".
354 while read mode sha1 stage path
356 # Skip already registered paths
357 name=$(module_name "$path") || exit
358 url=$(git config submodule."$name".url)
359 test -z "$url" || continue
361 url=$(git config -f .gitmodules submodule."$name".url)
363 die "No url found for submodule path '$path' in .gitmodules"
365 # Possibly a url relative to parent
368 url=$(resolve_relative_url "$url") || exit
372 git config submodule."$name".url "$url" ||
373 die "Failed to register url for submodule path '$path'"
375 upd="$(git config -f .gitmodules submodule."$name".update)"
377 git config submodule."$name".update "$upd" ||
378 die "Failed to register update mode for submodule path '$path'"
380 say "Submodule '$name' ($url) registered for path '$path'"
385 # Update each submodule path to correct revision, using clone and checkout as needed
387 # $@ = requested paths (default to all)
391 # parse $args after "submodule ... update".
409 case "$2" in '') usage ;; esac
410 reference="--reference=$2"
411 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
434 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
440 cmd_init "--" "$@" || return
445 while read mode sha1 stage path
449 echo >&2 "Skipping unmerged submodule $path"
452 name=$(module_name "$path") || exit
453 url=$(git config submodule."$name".url)
454 update_module=$(git config submodule."$name".update)
457 # Only mention uninitialized submodules when its
458 # path have been specified
460 say "Submodule path '$path' not initialized" &&
461 say "Maybe you want to use 'update --init'?"
465 if ! test -d "$path"/.git -o -f "$path"/.git
467 module_clone "$path" "$url" "$reference"|| exit
468 cloned_modules="$cloned_modules;$name"
471 subsha1=$(clear_local_git_env; cd "$path" &&
472 git rev-parse --verify HEAD) ||
473 die "Unable to find current revision in submodule path '$path'"
476 if ! test -z "$update"
478 update_module=$update
481 if test "$subsha1" != "$sha1"
484 if test -z "$subsha1"
489 if test -z "$nofetch"
491 # Run fetch only if $sha1 isn't present or it
492 # is not reachable from a ref.
493 (clear_local_git_env; cd "$path" &&
494 ((rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
495 test -z "$rev") || git-fetch)) ||
496 die "Unable to fetch in submodule path '$path'"
499 # Is this something we just cloned?
500 case ";$cloned_modules;" in
502 # then there is no local change to integrate
506 case "$update_module" in
518 command="git checkout $force -q"
524 (clear_local_git_env; cd "$path" && $command "$sha1") ||
525 die "Unable to $action '$sha1' in submodule path '$path'"
526 say "Submodule path '$path': $msg '$sha1'"
529 if test -n "$recursive"
531 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
532 die "Failed to recurse into submodule path '$path'"
541 git describe "$2" 2>/dev/null ||
542 git describe --tags "$2" 2>/dev/null ||
543 git describe --contains "$2" 2>/dev/null ||
544 git describe --all --always "$2"
547 test -z "$revname" || revname=" ($revname)"
550 # Show commit summary for submodules in index or working tree
552 # If '--cached' is given, show summary between index and given commit,
553 # or between working tree and given commit
555 # $@ = [commit (default 'HEAD'),] requested paths (default all)
562 # parse $args after "submodule ... summary".
576 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
598 test $summary_limit = 0 && return
600 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
604 elif test -z "$1" -o "$1" = "HEAD"
606 # before the first commit: compare with an empty tree
607 head=$(git hash-object -w -t tree --stdin </dev/null)
608 test -z "$1" || shift
616 die "--cached cannot be used with --files"
622 # Get modified modules cared by user
623 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
624 sane_egrep '^:([0-7]* )?160000' |
625 while read mod_src mod_dst sha1_src sha1_dst status name
627 # Always show modules deleted or type-changed (blob<->module)
628 test $status = D -o $status = T && echo "$name" && continue
629 # Also show added or modified modules which are checked out
630 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
635 test -z "$modules" && return
637 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
638 sane_egrep '^:([0-7]* )?160000' |
640 while read mod_src mod_dst sha1_src sha1_dst status name
642 if test -z "$cached" &&
643 test $sha1_dst = 0000000000000000000000000000000000000000
647 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
649 100644 | 100755 | 120000)
650 sha1_dst=$(git hash-object $name)
656 echo >&2 "unexpected mode $mod_dst"
663 test $mod_src = 160000 &&
664 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
667 test $mod_dst = 160000 &&
668 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
672 case "$missing_src,$missing_dst" in
674 errmsg=" Warn: $name doesn't contain commit $sha1_src"
677 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
680 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
685 if test $mod_src = 160000 -a $mod_dst = 160000
687 range="$sha1_src...$sha1_dst"
688 elif test $mod_src = 160000
694 GIT_DIR="$name/.git" \
695 git rev-list --first-parent $range -- | wc -l
697 total_commits=" ($(($total_commits + 0)))"
701 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
702 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
705 if test $mod_dst = 160000
707 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
709 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
712 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
716 # Don't give error msg for modification whose dst is not submodule
717 # i.e. deleted or changed to blob
718 test $mod_dst = 160000 && echo "$errmsg"
720 if test $mod_src = 160000 -a $mod_dst = 160000
723 test $summary_limit -gt 0 && limit="-$summary_limit"
724 GIT_DIR="$name/.git" \
725 git log $limit --pretty='format: %m %s' \
726 --first-parent $sha1_src...$sha1_dst
727 elif test $mod_dst = 160000
729 GIT_DIR="$name/.git" \
730 git log --pretty='format: > %s' -1 $sha1_dst
732 GIT_DIR="$name/.git" \
733 git log --pretty='format: < %s' -1 $sha1_src
739 if test -n "$for_status"; then
740 if [ -n "$files" ]; then
741 echo "# Submodules changed but not updated:"
743 echo "# Submodule changes to be committed:"
746 sed -e 's|^|# |' -e 's|^# $|#|'
752 # List all submodules, prefixed with:
753 # - submodule not initialized
754 # + different revision checked out
756 # If --cached was specified the revision in the index will be printed
757 # instead of the currently checked out revision.
759 # $@ = requested paths (default to all)
763 # parse $args after "submodule ... status".
788 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
793 while read mode sha1 stage path
795 name=$(module_name "$path") || exit
796 url=$(git config submodule."$name".url)
797 displaypath="$prefix$path"
800 say "U$sha1 $displaypath"
803 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
805 say "-$sha1 $displaypath"
808 set_name_rev "$path" "$sha1"
809 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
811 say " $sha1 $displaypath$revname"
815 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
816 set_name_rev "$path" "$sha1"
818 say "+$sha1 $displaypath$revname"
821 if test -n "$recursive"
824 prefix="$displaypath/"
827 eval cmd_status "$orig_args"
829 die "Failed to recurse into submodule path '$path'"
834 # Sync remote urls for submodules
835 # This makes the value for remote.$remote.url match the value
836 # specified in .gitmodules.
861 while read mode sha1 stage path
863 name=$(module_name "$path")
864 url=$(git config -f .gitmodules --get submodule."$name".url)
866 # Possibly a url relative to parent
869 url=$(resolve_relative_url "$url") || exit
873 say "Synchronizing submodule url for '$name'"
874 git config submodule."$name".url "$url"
876 if test -e "$path"/.git
881 remote=$(get_default_remote)
882 git config remote."$remote".url "$url"
888 # This loop parses the command line arguments to find the
889 # subcommand name to dispatch. Parsing of the subcommand specific
890 # options are primarily done by the subcommand implementations.
891 # Subcommand specific options such as --branch and --cached are
892 # parsed here as well, for backward compatibility.
894 while test $# != 0 && test -z "$command"
897 add | foreach | init | update | status | summary | sync)
927 # No command word defaults to "status"
928 test -n "$command" || command=status
930 # "-b branch" is accepted only by "add"
931 if test -n "$branch" && test "$command" != add
936 # "--cached" is accepted only by "status" and "summary"
937 if test -n "$cached" && test "$command" != status -a "$command" != summary